Index: GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TerrainFrameListener.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TerrainFrameListener.cpp	(revision 866)
+++ GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TerrainFrameListener.cpp	(revision 867)
@@ -107,5 +107,5 @@
 mVisibilityThreshold(0),
 mAssumedVisibility(0),
-#if 0
+#if 1
 mCurrentAlgorithm(GtpVisibility::VisibilityEnvironment::COHERENT_HIERARCHICAL_CULLING),
 #else
@@ -154,5 +154,4 @@
 mRecordDemo(false),
 mSavePrecomputedFps(false),
-mUseArbQueries(false),
 mUseBufferedInputMouse(false),
 mVizScale(25)
@@ -234,10 +233,8 @@
 	mTimer = Root::getSingleton().getTimer();
 	mTimeFrameEnded = mTimeFrameStarted = mTimer->getMilliseconds();
-		
-	//if (mSceneMgr->getSceneNode("robot Entity1Node")->getAttachedObject(0)->getMovableType() == "Entity")
-	//	Ogre::LogManager::getSingleton().logMessage("found entity");
-	
-	// arb or nv queries
-	//mSceneMgr->setOption("UseArbQueries", &mUseArbQueries);
+	
+	if (0 && (mSceneMgr->getSceneNode("robot Entity1Node")->getAttachedObject(0)->getMovableType() == "Entity"))
+		Ogre::LogManager::getSingleton().logMessage("found entity");
+	
 	
 	// reset statistics
@@ -1137,20 +1134,4 @@
 }
 //-----------------------------------------------------------------------
-void TerrainFrameListener::toggleUseArbQueries()
-{
-	mUseArbQueries = !mUseArbQueries;
-
-	mSceneMgr->setOption("UseArbQueries", &mUseArbQueries);
-	
-	if (mUseArbQueries)
-	{
-		mUseArbQueriesInfo->setCaption(": ARB");
-	}
-	else
-	{
-		mUseArbQueriesInfo->setCaption(": NV");
-	}
-}
-//-----------------------------------------------------------------------
 void TerrainFrameListener::toggleShowViz()
 {
@@ -1351,8 +1332,4 @@
     case KC_E: // hack for recording demo using precomputed fps
 		mSavePrecomputedFps = !mSavePrecomputedFps;
-		break;
-	
-	case KC_Q:
-		toggleUseArbQueries();
 		break;
 	case KC_O:
@@ -1717,5 +1694,4 @@
 	initOverlayElement(&mAssumedVisibilityInfo, ext, "AssumedVisibility", top, ": 0"); top += vert_space;
 	initOverlayElement(&mCurrentObjectTypeInfo, ext, "CurrentObjectType", top, ": "); top += vert_space;
-	initOverlayElement(&mUseArbQueriesInfo, ext, "UseArbQueries", top, ": NV"); top += vert_space;
 	//initOverlayElement(&mHelpInfo, ext, "Help", top, ": "); top += vert_space;
 
Index: GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TerrainFrameListener.h
===================================================================
--- GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TerrainFrameListener.h	(revision 723)
+++ GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TerrainFrameListener.h	(revision 867)
@@ -184,11 +184,13 @@
 	void updateStats();
 
-	/** Toggles wether help screen is shown or not.
+	/** Toggles whether help screen is shown or not.
 	*/
 	void toggleShowHelp();
 	
-	/** Toggles wether shadows are shown or not.
+	/** Toggles whether shadows are shown or not.
 	*/
 	void toggleShowShadows();
+	/** if camera stats (e.g, location, orientation, ...) should be displayed-
+	*/
 	void toggleDisplayCameraDetails();
 	/** Takes screenshot of the current scene.
@@ -211,14 +213,11 @@
 	*/
 	void toggleShowOctree();
-	/** Toggles wether we use the initial depth pass.
+	/** Toggles whether we use the initial depth pass.
 	*/
 	void toggleUseDepthPass();
-	/** Toggles wether we use ARB or NV queries.
-	*/
-	void toggleUseArbQueries();
-	/** Toggles wether the visualization is shown.
+	/** Toggles whether the visualization is shown.
 	*/
 	void toggleShowViz();
-	/** Toggles wether the frames are recorded.
+	/** Toggles whether the frames are recorded.
 	*/
 	void toggleRecord();
@@ -316,5 +315,4 @@
 	OverlayElement *mTestGeometryForVisibleLeavesInfo;
 	OverlayElement *mUseDepthPassInfo;
-	OverlayElement *mUseArbQueriesInfo;
 	OverlayElement *mRenderedNodesInfo;
 	OverlayElement *mObjectsCountInfo;
@@ -344,5 +342,4 @@
 	bool mShowOctree;
 	bool mUseDepthPass;
-	bool mUseArbQueries;
 	bool mShowVisualization;
 	bool mCullCamera;